/*
Title:   Maria_32x128_1.ino
Author: Maria Timoc	timoc_marioara@yahoo.com
Date Created: 10-07-2018
Last Modified: 05-09-2018
Purpose: This is an example that displays informations like
pressure and temperature on a 32x128 RGB LED matrix.
reads a message from a cell phone using BLE communication module.
This example code is in the public domain.
 */
#include <Wire.h> // I2C communication library
#include <Barometer.h> // BMP-180 family library
#include <Adafruit_GFX.h>   // Core graphics library
#include <RGBmatrixPanel.h> // RGB Matrix hardware-specific library

#define OE   9  // Output Enable pin
#define LAT 10  // Latch pin
#define CLK 11  // Serial Clock pin
#define A   A0
#define B   A1
#define C   A2
#define D   A3

#define DS1307_ADDRESS  0x68	// DS3231 RTC chip I2C address 1101000 (104 decimal)
RGBmatrixPanel matrix(A, B, C, D, CLK, LAT, OE, false, 128); // RGB Matrix objec initialisation
Barometer myBarometer; // Barometer objec initialisation

const word Perioada = 1000;  // RTC read time stamp
byte ss, mm, hh, d, dw, m, y ;  // Date and time variables
word y2k;
float temperatura, atm;
long presiune, presiune_m;
long ts; // Time stamp variable
char raspuns[24];  // Bluetooth communication message string
boolean  stare = 0, secunda_flag = 1; // Some used flags
void setup() {
   Serial.begin(9600); // Sets the baud rate on Serial1
   Wire.begin();  // Sets I2C communication interface
   myBarometer.init();   // BMP180 sensor/I2C bus init

  matrix.begin();  // RGB matrix initialisation



  // draw some text!
  matrix.setTextSize(1);     // size 1 == 8 pixels high
  matrix.setTextWrap(false); // Don't wrap at end of line - will do ourselves


   matrix.setCursor(7, 0);   //First line

  char *str2 = "Inginerie Electrica";
  {
    matrix.setTextColor(matrix.Color333(0, 7, 0));
    matrix.print( str2);
  }

  matrix.setCursor(36, 8);    // Line 2
  uint8_t w = 0;
  char *str = "LED Matrix Display ";

  for (w = 0; w < 10; w++) { 

    matrix.setTextColor(matrix.Color333(0, 0, 7));             
    matrix.print(str[w]);
  }

  matrix.setCursor(35, 16) ;    // next line 3

  for (w = 10; w < 19; w++) {
    matrix.setTextColor(matrix.Color333(4, 4, 4));
    matrix.print(str[w]);
  }

    matrix.setTextColor(matrix.Color333(7, 0, 0));
    matrix.print("R ");
      matrix.setTextColor(matrix.Color333(0, 7, 0));
    matrix.print("G ");
      matrix.setTextColor(matrix.Color333(0, 0, 7));
    matrix.print("B");
  
  
    matrix.setCursor(0, 24);   //Last line 4
  matrix.setTextColor(matrix.Color333(7, 0, 0));
  matrix.print("+-0123456789ABCD@#$%&");



// Initializare HM-10 cu numele: "Display Maria"
  Serial.print("AT");
  Serial.write(0x0D);
  Serial.write(0x0A);

delay(1000);
/*
if (Serial.available()){
 while(Serial.available()){
 Serial.read();
  }
}//end if
  Serial.print("AT+NAMEDisplay Maria");
  Serial.write(0x0D);
  Serial.write(0x0A);

delay(1000);

if (Serial.available()){
 while(Serial.available()){
 Serial.read();
   }
 }//end if
  Serial.print("AT+RENEW");
  Serial.write(0x0D);
  Serial.write(0x0A);
delay(1000);
if (Serial.available()){
 while(Serial.available()){
 Serial.read();
  }
 }//end if
*/

  delay(2000);
  matrix.fillRect(0, 0, 128, 32, 0); //Sterge prima linie
  matrix.setCursor(0, 8);   //A doua linie
  matrix.setTextColor(matrix.Color333(4, 4, 4));
  matrix.print("Presiune: ");
  matrix.setCursor(112, 8);
  matrix.print("hPa");
  matrix.setCursor(0, 16);   //first line
  matrix.setTextColor(matrix.Color333(4, 4, 4));
  matrix.print("Temperatura: ");
  matrix.setCursor(112, 16);   //A treia linie
 // matrix.print((char)223);
  matrix.print("'C");

    matrix.setCursor(0, 24);   //Last line 4
  matrix.setTextColor(matrix.Color333(7, 0, 0));
//  matrix.print("+-0123456789ABCD@#$%&");
  matrix.print(" Inginerie Electrica");



    Read_DateTime();
    ts = millis();
}


void loop() {
//free(raspuns) ;
delay(10);

if (Serial.available()){
byte i = 0;
 while(Serial.available()){
 raspuns[i] = Serial.read();
 if ( raspuns[i] == 0x0D ) stare = 1;
  i++;
 delay(1);
  }
 }//end if Serial.available
if (stare == 1){
Serial.print(raspuns);
  matrix.fillRect(0, 24, 128, 8, 0); //Sterge a patra linie
  matrix.setCursor(0, 24);   //A patra linie
  matrix.setTextColor(matrix.Color333(4, 4, 4));
  matrix.print(raspuns);
 stare = 0;
free(raspuns) ;

} //end if stare
   if (millis() > ts + Perioada) {   
       ts = millis();
    Read_DateTime();
if (ss%10 !=0) secunda_flag = 1;

//delay(10);


  presiune_m = 0;
  temperatura = myBarometer.bmp085GetTemperature(myBarometer.bmp085ReadUT()); //Get the temperature, bmp085ReadUT MUST be called first
  byte samples=16;
    while (samples--){
 
    presiune = myBarometer.bmp085GetPressure(myBarometer.bmp085ReadUP());//Get the pressure
    presiune_m = presiune_m + presiune;
    } // end while

    presiune = presiune_m >> 4;// Se exprima in Pa = N/m^2
    atm = presiune / 101325;// Se exprima in kgf/cm^2



} //end if millis

  if ((secunda_flag == 1) && ss%10 == 0){
secunda_flag = 0;
  matrix.fillRect(0, 0, 128, 8, 0); //Sterge prima linie
  matrix.setCursor(0, 0);   //first line
  matrix.setTextColor(matrix.Color333(0, 7, 0));
//  matrix.print( ziua );
switch(dw){
	case 1:
	matrix.print( "Du");
	break;
	case 2:
	matrix.print( "Lu");
	break;
	case 3:
	matrix.print( "Ma");
	break;
	case 4:
	matrix.print( "Mi");
	break;
	case 5:
	matrix.print( "Jo");
	break;
	case 6:
	matrix.print( "Vi");
	break;
	case 7:
	matrix.print( "Sa");
	break;
	default:
	matrix.print( "?");
	break;
}
   char c[20];  // Construieste ziua-luna-anul ora:minute:secunde
  matrix.print( make_String(c,20) );  
  matrix.fillRect(53, 8, 56, 8, 0); //Sterge a doua linie
  matrix.setCursor(53, 8);   //A doua linie
  matrix.setTextColor(matrix.Color333(4, 4, 4));
  matrix.print(float(presiune)/100);
  matrix.fillRect(73, 16, 36, 8, 0); //Sterge prima linie
  matrix.setCursor(73, 16);   //A treia linie
  matrix.setTextColor(matrix.Color333(4, 4, 4));
  matrix.print(temperatura);


} //end if secunda_flag 
}//end loop
void Read_DateTime()
{
 //Read Date/Time from DS1307 RTC module using I2C protocol
    Wire.beginTransmission(DS1307_ADDRESS);	// I2C device
    Wire.write(0);						
    Wire.endTransmission();	// Internal register pointer.
    Wire.requestFrom(DS1307_ADDRESS, 7);// End transmission
    ss = bcd2bin(Wire.read() & 0x7F);	// 7 bytes from device
    mm = bcd2bin(Wire.read());   // Read the data...
    hh = bcd2bin(Wire.read());  // Read the data...
    dw = Wire.read();		// Read the day of the week...			
    d = bcd2bin(Wire.read());// Ziua
    m = bcd2bin(Wire.read());// Luna
    y = bcd2bin(Wire.read());// Anul
	y2k = 2000 + y;
}
  //Conversion functions from bcd to bin and viceversa
      uint8_t bcd2bin (uint8_t val)
{
    return val - 6 * (val >> 4);//val = val - 6 * (val / 16)
}
    uint8_t bin2bcd (uint8_t val)
{
    return val + 6 * (val / 10);//val = val + 6 * (val / 10)
}
char* make_String(char* buf, int maxlen) {
	snprintf(buf,maxlen,"%02u-%02u-%04u %02u:%02u:%02u",
			d,    
			m,
			y2k,
		hh,
		mm,
		ss
        );
    return buf;
}